#include <VirtualRobot/Robot.h>
#include <VirtualRobot/VirtualRobotException.h>
#include <VirtualRobot/Nodes/RobotNode.h>
#include <VirtualRobot/XML/RobotIO.h>
#include <VirtualRobot/Visualization/VisualizationFactory.h>
#include <VirtualRobot/Visualization/CoinVisualization/CoinVisualization.h>
#include <VirtualRobot/RuntimeEnvironment.h>



#include <Inventor/Qt/viewers/SoQtExaminerViewer.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/Qt/SoQt.h>
#include <boost/shared_ptr.hpp>
#include <string>
#include <iostream>

using std::cout;
using std::endl;
using namespace VirtualRobot;

#include <Eigen/Core>
#include <Eigen/Geometry>

#include "PathPlanningWindow.h"


int main(int argc, char *argv[])
{
	SoDB::init();
    SoQt::init(argc,argv,"PathPlanning");

    //std::string sceneFile("robots/ArmarIII/ArmarIII.xml");

   /* std::string robotName ("ArmarIII");
    std::string config1 ("start");
    std::string config2 ("end");

    cout << "Using scene file " << sceneFile << endl;*/

    PathPlanningWindow* rw = new PathPlanningWindow();

    rw->main();
    delete rw;
    SoDB::cleanup();

	return 0;

}
